---@alias XyPair { x: number, y: number }

---@alias Entity table

---@alias Collision { collisionBetween: Entity[] }

---@type Entity
local Entity = {}

---@type XyPair
local XyPair = { x = 1, y = 1 }

---@alias BitMask number

---@alias CanBeBounced { flat: XyPair, mult: XyPair }

---@alias RoundStateAction "end" | "start"

T = {
    XyPair = XyPair,
    bool = true,
    number = 0,
    ---@type BitMask
    bitMask = 0,
    numberArray = { 1, 2, 3 },
    str = "",
    marker = {},
    ---@type fun(self)
    SelfFunction = function(self) end,
    --- Actor
    CanBounce = {
        isSolid = true,
        flat = XyPair,
        mult = XyPair,
    },
    --- Receiver
    ---@type CanBeBounced
    CanBeBounced = {
        flat = XyPair,
        mult = XyPair,
    },
    ---@type Collision
    Collision = { Entity, Entity },
    ---@type pd_image
    PdImage = {},
    ---@type RoundStateAction
    RoundStateAction = "start"
}

---@generic T
---@param t T
---@return nil | T
function Maybe(t)
    return { maybe = t }
end
