collectedEntities = filteredSystem({ collected = T.PdImage })

roundSystem = filteredSystem({ roundAction = T.RoundStateAction, position = Maybe(T.XyPair) }, function(e, _, system)
    if e.roundAction == "end" then
        playdate.setAutoLockDisabled(false)
        local y = e.position.y - 240
        local rectWidth = 150
        local plateSize = { x = rectWidth, y = 10 }

        system.world:addEntity({
            drawAsRectangle = { size = plateSize },
            size = plateSize,
            mass = 0.5,
            velocity = { x = 0, y = 0 },
            position = { x = e.position.x - (rectWidth / 2), y = y },
            canCollideWith = 2,
            canBeCollidedBy = 2,
            isSolid = true,
            stopMovingOnCollision = true,
        })

        for i, collectable in ipairs(collectedEntities.entities) do
            local collX, collY = collectable.collected:getSize()
            local onCollidingRemove = {"mass", "velocity", "canCollideWith"}
            y = y - collY - 15
            system.world:addEntity({
                drawAsSprite = collectable.collected,
                size = { x = collX, y = collY / 2 },
                mass = 0.5,
                velocity = { x = 0, y = 0 },
                position = { x = e.position.x - (collX / 2), y = y },
                canCollideWith = 2,
                canBeCollidedBy = 2,
                isSolid = true,
                stopMovingOnCollision = true,
                onCollidingRemove = onCollidingRemove,
                focusOnCollide = i,
            })
            system.world:removeEntity(collectable)
        end
        system.world:removeEntity(e)
    end
end)